//ACHTUNG!
//Sie handeln auf eigene Gefahr!
//Bei diesen Daten handelt es sich um Beispielanwendungen die nicht fr den produktiven
//Einsatz geeignet sind.
//Pollin Electronic gibt keine Garantien irgendeiner Art, weder ausdrcklich
//noch implizit, einschlielich unbegrenzt aller Garantien der Verwendbarkeit
//dieser Daten fr einen bezeichneten oder nicht bezeichneten Zweck.
//Pollin Electronic ist nicht haftbar fr jedwede Folgeschden die aufgrund
//der Benutzung dieser Daten entstehen. Dies gilt auch dann, wenn
//Pollin Electronic von der Mglichkeit eines solchen Schadens unterrichtet worden ist.

//Hyperterminalsteuerung:
//Einstellungen im Hyperterminal:
//Baudrate: 9600
//Data: 8
//Stop: 1
//Parity: none
//
//Mit den Buchstaben
//a = Blitzgeschwindigkeit
//b = Blinkgeschwindigkeit
//c = Zeit Phase1/Phase5
//d = Zeit Phase2/Phase6
//e = Zeit Phase3/Phase7
//f = Zeit Phase4/Phase8
//auswhlen welche Zeit verndert werden soll!
//
//anschlieend mit einer Ziffer von 0-9, Geschwindigkeit whlen
//9 heit, es wechselt am schnellsten



#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/sleep.h>
#include <string.h>


#define true 1
#define false 0
#define NOP asm("nop")

#define sync PORTC&=~(1<<PC0)
#define black PORTC|=(1<<PC0)
#define test PORTC|=(1<<PC2)




volatile unsigned char status_ampel = 1;
volatile unsigned char status_blink = 0;
volatile unsigned char wechsel_phase_1 = 1;
volatile unsigned char wechsel_phase_2 = 0;
volatile unsigned char wechsel_phase_3 = 0;
volatile unsigned char wechsel_phase_4 = 0;
volatile unsigned char wechsel_phase_5 = 1;
volatile unsigned char wechsel_phase_6 = 0;
volatile unsigned char wechsel_phase_7 = 0;
volatile unsigned char wechsel_phase_8 = 0;
volatile unsigned char phase5_8_komplett = 1;
volatile unsigned char phase1_4_komplett = 1;
volatile unsigned char ampel_wechsel_moeglich = 1;

//Voreingestellte Werte fr die Geschwindigkeit der Phasenwechsel
volatile unsigned int time_blitzlicht = 7000;
volatile unsigned int time_blinklicht = 10000;
volatile unsigned int time_phase1 = 60000;
volatile unsigned int time_phase2 = 60000;
volatile unsigned int time_phase3 = 60000;
volatile unsigned int time_phase4 = 60000;


volatile unsigned char flag_blitz = 0;
volatile unsigned char flag_blink = 0;
volatile unsigned char flag_phase1 = 0;
volatile unsigned char flag_phase2 = 0;
volatile unsigned char flag_phase3 = 0;
volatile unsigned char flag_phase4 = 0;


volatile unsigned int blink_counter = 0;
volatile unsigned int blitz_counter = 0;
volatile unsigned int phase1_counter = 0;
volatile unsigned int phase2_counter = 0;
volatile unsigned int phase3_counter = 0;
volatile unsigned int phase4_counter = 0;
volatile unsigned int phase5_counter = 0;
volatile unsigned int phase6_counter = 0;
volatile unsigned int phase7_counter = 0;
volatile unsigned int phase8_counter = 0;



//Port_init
void port_init(void){
//Eingaenge
DDRA = 0x00;


//Ausgaenge
DDRB = 0xFF; //alles Ausgaenge
PORTB = 0x00;

DDRD = (1<<PD2)|(1<<PD3)|(1<<PD4)|(1<<PD5)|(1<<PD6);
PORTD = 0x00;

}





void uart_init(void)
{
	 UCSRB = 0x00; //disable while setting baud rate
	 UCSRA = 0x20;
	 UCSRC = ((1<<UCSZ1)|(1<<UCSZ0));	//8 bits data & 1 stop bit 
	//UART SPEED 9200 bs
	UBRRL = 0x19; //set baud rate lo
	UBRRH = 0x00; //set baud rate hi

	UCSRB = (1<<RXEN);
}

//diese Funktion managed die Hyperterminal Eingabe
void uart_handler(){

while(UCSRA & (1<<RXC))
{
	unsigned char received_symbol = 0;

	received_symbol = UDR;
	
	if(flag_blitz)
		{
			flag_blitz = 0;
			blitz_counter = 0;
			time_blitzlicht = ((received_symbol-48)*6111)+5000;
		
		}
	
	else if(flag_blink)
		{
			
			flag_blink = 0;
			blink_counter = 0;
			time_blinklicht = ((received_symbol-48)*6111)+10000;			
		}

	else if(flag_phase1)
		{
			flag_phase1 = 0;
			phase1_counter = 0;
			phase5_counter = 0;
			time_phase1 = ((received_symbol-48)*6111)+10000;		
		}

	else if(flag_phase2)
		{
			flag_phase2 = 0;
			phase2_counter = 0;
			phase6_counter = 0;
			time_phase2 = ((received_symbol-48)*6111)+10000;			
		}

	else if(flag_phase3)
		{
			flag_phase3 = 0;
			phase3_counter = 0;
			phase7_counter = 0;
			time_phase3 = ((received_symbol-48)*6111)+10000;			
		}
	else if(flag_phase4)
		{
			flag_phase4 = 0;
			phase4_counter = 0;
			phase8_counter = 0;
			time_phase4 = ((received_symbol-48)*6111)+10000;			
		}		
	
	else{	
		
		//Hier werden die Zeiten ausgewhlt die man verndern mchte
		//Phase1 steht auch fr Phase 5
		//Phase2 fr Phase6
		//Phase3 fr Phase7
		//Phase4 fr Phase8
		//da diese Paare immer die gleichen Zeiten haben.
		switch (received_symbol)
			{
			
			//blitz
			case 0x61:
				
					flag_blitz = 1;
				break;
					
			//blink
			case 0x62:
					
					
					flag_blink = 1;

				break;

			//phase1
			case 0x63:
					
					flag_phase1 = 1;

				break;



			//phase2
			case 0x64:
					
					flag_phase2 = 1;

				break;



			//phase3
			case 0x65:
					
					flag_phase3 = 1;

				break;



			//phase4
			case 0x66:
					
					flag_phase4 = 1;

				break;

			 default: ;
			
			//}

}}
}
}

//Funktionen zum ein/ausschalten der Ausgangsports(LEDs)
void blink1_ein(void)
{
PORTD |= (1<<PD2);
PORTD &= ~(1<<PD3);
}

void blink2_ein(void)
{
PORTD |= (1<<PD3);
PORTD &= ~(1<<PD2);
}

void blink_aus(void)
{
PORTD &= ~((1<<PD2)|(1<<PD3));
}

void blitz(void)
{
PORTD ^= (1<<PD4);
}

void AA1_rot(void)
{
PORTB |= (1<<PB7);
PORTB &= ~((1<<PB6)|(1<<PB5));
}

void FA1_rot(void)
{
PORTB |= (1<<PB1);
PORTB &= ~(1<<PB0);
}

void AA2_rot(void)
{
PORTB |= (1<<PB4);
PORTB &= ~((1<<PB3)|(1<<PB2));
}

void FA2_rot(void)
{
PORTD |= (1<<PD6);
PORTD &= ~(1<<PD5);
}

void AA1_zu_rot(void)
{
PORTB |= (1<<PB6);
PORTB &= ~((1<<PB7)|(1<<PB5));
}

void AA2_zu_rot(void)
{
PORTB |= (1<<PB3);
PORTB &= ~((1<<PB4)|(1<<PB2));
}

void AA1_zu_gruen(void)
{
PORTB |= ((1<<PB6)|(1<<PB7));
PORTB &= ~(1<<PB5);
}

void AA2_zu_gruen(void)
{
PORTB |= ((1<<PB3)|(1<<PB4));
PORTB &= ~(1<<PB2);
}

void AA1_gruen(void)
{
PORTB |= (1<<PB5);
PORTB &= ~((1<<PB6)|(1<<PB7));
}

void FA1_gruen(void)
{
PORTB |= (1<<PB0);
PORTB &= ~(1<<PB1);
}

void AA2_gruen(void)
{
PORTB |= (1<<PB2);
PORTB &= ~((1<<PB3)|(1<<PB4));
}

void FA2_gruen(void)
{
PORTD |= (1<<PD5);
PORTD &= ~(1<<PD6);
}

//Funktion zum abfragen des Zustands des Tasters1
void taster1(void)
{
 

	if (PINA & (1<<PINA1))
		{	
			if(status_blink)
				status_blink = 0;
			else
				status_blink = 1;
		while(PINA & (1<<PINA1));
		}
	
}

//Funktion zum abfragen des Zustands des Tasters2
void taster2(void)
{
	
	if (PINA & (1<<PINA0))
		{
		if(ampel_wechsel_moeglich)
			{
			if(status_ampel)
				status_ampel = 0;
			else
				status_ampel = 1;
				
			ampel_wechsel_moeglich = 0;
			}
		while(PINA & (1<<PINA0));
		}

}


void main(void)
	{

uart_init();
port_init();

unsigned char blitz_var = 0;

	//Polling - Schleife
	while(1)
		{
		sei();
		
		if(UCSRA & (1<<RXC)) //Abfrage ob Zeichen im UART
			uart_handler();	
		
		//Taster Abfrage
		taster1();
		taster2();
		
		//Blitzlicht
		blitz_counter++;
		if(blitz_counter == time_blitzlicht)
			{
			blitz_counter = 0;
			blitz_var++;
			if(blitz_var >= 8)
			blitz();
			}
		if(blitz_var == 10)
			blitz_var = 0;
			
			
			
			
		//Blitzlicht_ENDE
		
		//Blinklicht
		if(status_blink)
			{
			blink_counter++;
			if(blink_counter == time_blinklicht)
				blink_counter = 0;
				
			else;
			if(blink_counter<(time_blinklicht/2))
				blink1_ein();
			else
			blink2_ein();
			
			
			}
		else
			{
			blink_aus();
			blink_counter = 0;
			}
		//Blinklicht_ENDE
		
		
		//Ampelsteuerung
		//Die verschiedenen Phasen werden nacheinander durchlaufen
		//Dabei gehren Phase 1-4 und Phase 5-8 jeweils zusammen, bei Tastendruck wird von Phase 1-4 zu Phase 5-8 bergegangen, oder umgekehrt
		//
		if(!ampel_wechsel_moeglich)
		{
		
		if(status_ampel)	
			{
			
			if(wechsel_phase_1)
				{
				phase1_counter++;
				if(phase1_counter == time_phase1)
					{
					phase1_counter = 0;
					AA1_zu_rot();
					FA1_rot();
					AA2_rot();
					FA2_rot();
					wechsel_phase_1 = 0;
					wechsel_phase_2 = 1;
					}
				}
			
			if(wechsel_phase_2)
				{
				phase2_counter++;
				if(phase2_counter == time_phase2)
					{
					phase2_counter = 0;
					AA1_rot();
					FA1_rot();
					AA2_rot();
					FA2_rot();
					wechsel_phase_2 = 0;
					wechsel_phase_3 = 1;
					}
				}
		
			if(wechsel_phase_3)
				{
				phase3_counter++;
				if(phase3_counter == time_phase3)
					{
					phase3_counter = 0;
					AA1_rot();
					FA1_rot();
					AA2_zu_gruen();
					FA2_gruen();
					wechsel_phase_3 = 0;
					wechsel_phase_4 = 1;
					}
				}
			if(wechsel_phase_4)
				{
				phase4_counter++;
				if(phase4_counter == time_phase4)
					{
					phase4_counter = 0;
					AA1_rot();
					FA1_rot();
					AA2_gruen();
					FA2_gruen();
					wechsel_phase_4 = 0;
					wechsel_phase_1 = 1;
					phase1_4_komplett = 1;
					
					ampel_wechsel_moeglich = 1;
					}				
				}
			}
		else
			{	
			if(wechsel_phase_5)
				{
				phase5_counter++;
				if(phase5_counter == time_phase1)
					{
					phase5_counter = 0;
					AA1_rot();
					FA1_rot();
					AA2_zu_rot();
					FA2_rot();
					wechsel_phase_5 = 0;
					wechsel_phase_6 = 1;
					}
				}
				
			if(wechsel_phase_6)
				{
				phase6_counter++;
				if(phase6_counter == time_phase2)
					{
					phase6_counter = 0;
					AA1_rot();
					FA1_rot();
					AA2_rot();
					FA2_rot();
					wechsel_phase_6 = 0;
					wechsel_phase_7 = 1;
					}
				}
				
			if(wechsel_phase_7)
				{
				phase7_counter++;
				if(phase7_counter == time_phase3)
					{
					phase7_counter = 0;
					AA1_zu_gruen();
					FA1_gruen();
					AA2_rot();
					FA2_rot();
					wechsel_phase_7 = 0;
					wechsel_phase_8 = 1;
					}
				}
				
			if(wechsel_phase_8)
				{
				phase8_counter++;
				if(phase8_counter == time_phase4)
					{
					phase8_counter = 0;
					AA1_gruen();
					FA1_gruen();
					AA2_rot();
					FA2_rot();
					wechsel_phase_8 = 0;
					wechsel_phase_5 = 1;
					phase5_8_komplett = 1;
					
					ampel_wechsel_moeglich = 1;
					}
				}
			
			}
		}//Ende Ampelsteuerung


	}
}



